; Further reduction programs --  Must be used with  graph, reduca

; Functions from reduca.lisp

(proclaim '(type function newc!! 2newc!! 5newc!!))

; Temporary substitute for (*psetno F F A) - simulator has bug

(*defun sim*pset (F A)
 (declare (type (field-pvar CA-SZ) A))
  (*let (X N)
	(declare (type boolean-pvar N))
     (*all (*set N nil!!))
     (*pset :no-collisions F X A N)
     (*all (*if N (*set F X)))
   )  ; end *let
)

; Copies structures as required, making sure there's enough space
; Uses VIST to identify copied nodes.  MRKT is working Boolean.
; Returns pointer to copies of XC in CPYP.  Performs 5newc!! if nw = 5,
; performs newc!! if nw = 1, either with ty-comb.  Variables are
; copied if their scopes are copied or their scopes are flagged in CTVT.
; Not intended for use with no processors selected.

(*defun another (XC nw)
"(another XC nw)  -- copy structures rooted in XC, if there's room to
                    allocate nw additional nodes per active node"
 (declare (type (field-pvar CZ-SZ) XC)) (declare (type fixnum nw))
 (let (nc (success nil))
  (*set D (self-address!!))
  (*pset :or T!! VIST XC)
  (marker)
  (*all (*set SCPT (or!! VIST CTVT))
     (*if VIST
	(*if (or!! NRMT
		   (and!! (VARP!!) (hgh!! CXTP) (not!! (pref!! SCPT CXTP))))
	     (progn (*set D (self-address!!)) (sV!! nil!!))
	     (setq nc (*sum (!! 1))))))
  (when (<= (+ nc (if (plusp nw) (* nw (*sum (!! 1))) 0)) CFREE)
    (*all (*when VIST (newc!! (ty-dummy))
       (*psetno GTYP GTYX D)
;;; (stest "before *pset") (report) (print D)
;;;       (*psetno STRT STRT D)  PREFERRED FORM - simulator bug
       (sim*pset STRT D)
;;; (stest "after *pset")
       (*when (VLP!!)
	 (*if (<!! LPTR (!! ATML)) (*set E LPTR) (*set E (pref!! D LPTR)))
	 (*psetno E LPTX D))
       (*when (VRP!!)
	 (*if (<!! RPTR (!! ATML)) (*set E RPTR) (*set E (pref!! D RPTR)))
	 (*psetno E RPTX D))
       (*when (VCP!!)
	 (*if (<!! CXTP (!! ATML)) (*set E CXTP) (*set E (pref!! D CXTP)))
	 (*psetno E CXTX D) (sim*pset XNMB D))))
;;; (stest "after copying")
    (*set CPYP (pref!! D XC))
    (setq success t))
  success
 )  ; end let
)  ; end another

; Not used as "go to" function:

(*defun fxAND (XA XB XC)
"(fxAND XA XB XC) -- reduction for (and (or XA XB) XC) or reverse"
 (declare (type (field-pvar CA-SZ) XA XB XC))
 (*set CTVT nil!!)
 (if (and (or (not (eq SCHEME 'A)) (another XC 5)) (5newc!! CB-or CB-and))
     (progn (sLX!! C) (sRX!! F)
	    (*psetno XC RPTX D)
	    (*psetno XA RPTX E)
	    (*psetno (if (eq SCHEME 'A) CPYP XC) RPTX F)
	    (*psetno XB RPTX G)
	    (*all (sV!! nil!!)))
     (progn (*set NX (cCXT!!))  (*set RDTN (!! 0))))
)

(defun fx5NW ()
"Links together structures created with 5newc!!"
 (*psetno  D RPTX C) (*psetno E LPTX D) (*psetno G LPTX F)
)

; Arguments are A, B, with types ATY BTY

(defun two-arguments ()
"(two-arguments) -- handles two-argument applications, opr is sysc"
 (sRN!! (load-byte!! LL (!! 0) (!! TY-SZ)))
 (*cond*
    ((=!! RDTN (!! CB-=)) (*set NX (cPNT!!))
     (*cond ((=!! A B) (sRX!! (!! CB-true)))
	    ((and!! (=!! ATY (!! (ty-numb))) (=!! BTY (!! (ty-numb))))
	     (*if (=!! (X!! A) (X!! B))
		  (sRX!! (!! CB-true))  (sRX!! (!! CB-false))))
	    ((or!! (and!! (atomic A ATY)
			  (or!! (=!! BTY (!! (ty-cons))) (atomic B BTY)))
		   (and!! (=!! ATY (!! (ty-cons))) (atomic B BTY)))
	     (sRX!! (!! CB-false)))
	    ((not!! LQNT) (unify))
	    (T!! (sRN!! (!! 255)))))
    ((and!! (=!! RDTN (!! CB-is)) (=!! ATY (!! (ty-numb))))
     (sX!! (X!! A)) (*if (plusp!! XNMB) (reduce-is) (sRN!! (!! 255))))
    ((=!! RDTN (!! CB-K2)) (sRX!! B) (*set NX (cPNT!!)))
    ((bit!! RDTN 5) (arithmetic))
    ( LQNT   (sRN!! (!! 255))
      (*if (or!! (=!! RDTN (!! CB-K)) (=!! RDTN (!! CB-W)) (bit!! RDTN 6)
		 (<=!! (!! CB-and) RDTN (!! CB-or)))
	   (*set NX (!! 0))
	   (*set NX (cNM!!))))
    ((=!! RDTN (!! CB-K)) (sRX!! A) (*set NX (cPNT!!)))
    ((=!! RDTN (!! CB-W))
     (if (newc!! (ty-comb))
	 (progn (*psetno A LPTX D) (*psetno B RPTX D) (sLX!! D))
         (sRN!! (!! 255))))
    ((bit!! RDTN 6)                     ; *xB combinator
     (if (2newc!! (ty-comb) (ty-comb))
	 (progn (*psetno (!! CB-B) LPTX D)  (*psetno A RPTX D)
		(*psetno D LPTX E)          (*psetno B RPTX E)
		(sLX!! (logxor!! RDTN (!! 64))) (sRX!! E))
         (sRN!! (!! 255))))
    ((=!! RDTN (!! CB-and)) (*set NX (cPNT!!))
     (*cond ((=!! B (!! CB-false)) (*set RPTX (!! CB-false)))
	    ((=!! B (!! CB-true)) (*set RPTX A))
	    (T!! (*set NX (cCHK!!)))))
    ((=!! RDTN (!! CB-or))  (*set NX (cPNT!!))
     (*cond ((=!! B (!! CB-true))  (sRX!! B))
	    ((=!! B (!! CB-false)) (sRX!! A))
	    ((zerop!! QNTC) (*set NX (cNM!!)))
	    (T!! (live (*set NX (!! 0))
		       (if (not (fxOR)) (*set RDTN (!! 255)))))))
    (T!! (*if (<=!! (!! CB-S) RDTN (!! CB-C)) (*set IRRT T!!))
	 (*set NX (cNM!!)) (sRN!! (!! 255)))
 )
) ; end two-arguments

(defun arithmetic ()
"(arithmetic) -- handles arith ops and predicates"
 (*if* (and!! (=!! ATY (!! (ty-numb))) (=!! BTY (!! (ty-numb))))
  (*let ((bx (X!! B)))  ; (declare (type signed-pvar bx))
    (sX!! (X!! A))
    (*if* (<=!! RDTN (!! CB-/))
       (progn
         (*cond  ((=!! RDTN (!! CB-+)) (sX!! (+!! XNMB bx)))
                 ((=!! RDTN (!! CB--)) (sX!! (-!! XNMB bx)))
	         ((=!! RDTN (!! CB-*)) (sX!! (*!! XNMB bx)))
	         ((zerop!! bx) (sRX!! (!! CB-inf)) (*set NX (cPNT!!)))
	         (T!! (sX!! (truncate!! XNMB bx))))
         (sGX!! (!! (ty-numb))) (sN!! T!!))
       (progn (*set NX (cPNT!!))
         (*cond  ((=!! RDTN (!! CB-<)) (sV!! (<!! XNMB bx)))
	         ((=!! RDTN (!! CB-<=)) (sV!! (<=!! XNMB bx)))
	         ((=!! RDTN (!! CB->)) (sV!! (>!! XNMB bx)))
	         (T!! (sV!! (>=!! XNMB bx))))
	 (*if VIST (*set RPTX (!! CB-true)) (*set RPTX (!! CB-false)))
         (sV!! nil!!)))
    ) ; end *let
   (*set RDTN (!! 255))
  ) ; end *if
)

; PNT is next unless NX is altered:

(defun unify ()
"(unify) -- attempts unification of = A B in context of two-arguments"
 (*cond* ((and!! (bit!! ATY 7) (bit!! ATY 6) (bit!! BTY 7) (bit!! BTY 6))
	  (*if (and!! (S!! A) (S!! B))
	    (*if (=!! ATY BTY) (*set NX (cSPL!!)) (sRX!! (!! CB-false)))
	    (*set NX (cNM!!))))
	 ((if!! (and!! (=!! ATY (!! (ty-var)) BTY) (=!! (C!! A) CXTP (C!! B)))
	    (progn (*set C (min!! A B)) (*set D (max!! A B)) T!!)
	    (if!! (and!! (=!! ATY (!! (ty-var))) (/=!! BTY (!! (ty-point)))
			 (=!! (C!! A) CXTP))
	      (progn (*set C A) (*set D B) T!!)
	      (if!! (and!! (=!! BTY (!! (ty-var))) (/=!! ATY (!! (ty-point)))
			   (=!! (C!! B) CXTP))
		(progn (*set C B) (*set D A) T!!) NIL!!)))
	  (*pset :logior (!! (ty-point)) GTYX C)
	  (*pset :logior (!! 131) RDTN C)
	  (*pset :overwrite D RPTX C) (*set NX (!! 0)))
	 (T!! (*set NX (cNM!!))))
)

; Used only by fxCHK, below.  Doesn't accept Ex-quantified or's.

(*defun and-or-test (XTY X)
"X points to arg of type XTY"
(declare (type (field-pvar TY-SZ) XTY) (type (field-pvar CA-SZ) X))
 (and!! (=!! XTY (!! (ty-comb)))
	(not!! (pref!! QNTT X))
        (progn (*set E X) (*set D (L!! E)) (>=!! D (!! ATML)))
        (=!! (G!! D) (!! (ty-comb)))
        (=!! (L!! D) (!! CB-or)))
)

; Not intended for use with no processors active.

(defun fxCHK ()
"Check for (and --- or ---) reductions"
 (*if (cond!! ((and-or-test ATY A))
	      ((and-or-test BTY B) (*set B A) T!!))
      (fxAND (R!! D) (R!! E) B)
      (*set NX (cCXT!!)))
)

; X has number of variables, assumed >= 1.  B, TYB from two-args.

(defun reduce-is ()
"Performs is-reduction if possible.  Takes care of everything."
 (sX!! (1-!! (ash!! XNMB (!! 1))))   ; number of new nodes
 (let ((cf CFREE) (nx (*sum XNMB)) rva)
   (when (> nx CFREE)
	 (*set NX (!! 0)) (*set RDTN (!! 255))(return-from reduce-is nil))
   (setq CFREE (- CFREE nx))  (setq rva (- MXCA nx))
   (*set CXTX (self-address!!))
   ; C is beginning of rendezvous, D is end.
   (*set C (-!! (+!! (scan!! XNMB '+!!) (!! rva)) XNMB))
   (*set D (+!! C (1-!! XNMB)))
   (*psetno T!! VIST C)  (*psetno CXTX RV C)
   (*all (*when (>=!! (self-address!!) (!! rva))
		(*set RV (scan!! RV 'copy!! :segment-pvar VIST))))
   (*all (*when (and!! (FREEP!!) (>=!! REFC (!! CFREE)))
      (sG!! (!! (ty-new)))  (sRN!! (!! 254))
      (*set E (+!! REFC (!! (- MXCA cf))))  ; RV address
      (sCX!! (RV!! E)) (sS!! (V!! E)) (sF!! (!! 0))
      (*psetno (self-address!!) RV E)
      (*set F (scan!! (!! 1) '+!! :segment-pvar STRT))
      ; procs with odd F become vars, other combs
      (sRX!! (scan!! (self-address!!) 'copy!!
		     :segment-pvar T!! :include-self nil))
      (*if (evenp!! F)
	   (progn  (sGX!! (!! (ty-comb))) (sCX!! (self-address!!))
	      (*when (>!! F (!! 2)) (sLX!! (RX!! RPTX))))
	   (progn (sGX!! (!! (ty-var))) (sRX!! (!! 0)) (sX!! (!! SYMIS))))
      (sS!! nil!!)
     ))  ; end *all for new processors
   (sRX!! (RV!! D))     ; new variable
   (*if (=!! XNMB (!! 1)) (sLX!! B)
	(progn (sLX!! (RV!! (1-!! D))) (*psetno B LPTX (RV!! (1+!! C)))))
   (*all (sV!! nil!!))
  )
)  ; end reduce-is

(defun marker ()
"(marker) -- marks nodes from sources tagged in VIST, uses and resets MRKT"
  (do ((more t)) ((not more))
      (*all (*when (and!! VIST (not!! NRMT) (not!! MRKT)
			  (or!! (COMBP!!) (CONSP!!)))
	       (*if (hgh!! LPTR) (*pset :or T!! VIST LPTR))
	       (*if (hgh!! RPTR) (*pset :or T!! VIST RPTR))
	       (*set MRKT T!!) (setq more (*or T!!)))))
  (*all (*set MRKT nil!!))
)


; Test function used to track down simulator bug:

(defun stest (loc)
 (format T "(V CB-I) = ~A, (S CB-I) = ~A ~A~%"
	 (if (V CB-I) 'T 'F) (if (S CB-I) 'T 'F) loc)
)


; Implements all schemes, Returns T if successful.  NX is 0.
; Not intended for use with no processors selected

(defun fxOR ()
"(fxOR) -- implements (exists (x ...) (or a b)) reduction"
(let ((success T))
 (*set NX (!! 0))
 (cond ((eq SCHEME 'A)
	(*pset :or T!! VIST B) (marker)	(*set CTVT T!!)
	(*all
	 (BLOCK SCHEME-A
	  (*when (and!! (VARP!!) (hgh!! CXTP) (pref!! CTVT CXTP))
	     (sCX!! (pref!! A CXTP))  (sRN!! (!! 132))
	     (*when VIST
	       (when (not (newc!! (ty-var)))
		     (setq success nil) (return-from SCHEME-A nil))
	       (*psetno (pref!! B CXTP) CXTX D)
;;; (*psetno XNMB XNMB D)  Preferred except for simulator bug
	       (sim*pset XNMB D)
	       (*set CPYT T!!)))
	  (*when (and!! VIST (or!! (COMBP!!) (CONSP!!)))
		(*when (and!! (hgh!! LPTR) (pref!! CPYT LPTR))
		    (*set LPTX (pref!! D LPTR)) (sRN!! (!! 129)))
		(*when (and!! (hgh!! RPTR) (pref!! CPYT RPTR))
		    (*set RPTX (pref!! D RPTR)) (sRN!! (!! 129))))
	   ) ; end SCHEME-A
	 (*set VIST nil!!) (*set CPYT nil!!)) ; end *all
	(*set CTVT nil!!))  ; end scheme A
       ((eq SCHEME 'B)
	     (*set CTVT T!!)
	     (if (not (another B 0)) (setq success nil)
	       (*all
		(*when (and!! (VARP!!) (hgh!! CXTP) (pref!! CTVT CXTP))
		   (sCX!! (pref!! A CXTP))  (sRN!! (!! 132))
		   (*when VIST (*psetno (pref!! CPYP CXTP) CXTX D)))
		(sV!! NIL!!)))  ; end if - *all
	     (sRX!! CPYP) (*set CTVT nil!!))  ; end scheme B
       ((eq SCHEME 'C) nil))
 (if (not success) (sRN!! (!! 255)))
 success) ; end let
)
       
